﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import flash.geom.ColorTransform;
	import flash.display.DisplayObject;
	
	import com.actionscriptfacile.ui.text.UITextField;
	
	import flash.net.navigateToURL;
	import flash.net.URLRequest;
	
	import flash.events.ContextMenuEvent;
	import flash.ui.ContextMenuItem;
	import flash.ui.ContextMenu;
	
	import com.demonsters.debugger.MonsterDebugger;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	// definit la couleur de fond du swf
	[SWF(backgroundColor="0x02313B")] 

	public class Main extends Sprite
	{
		private var oMenu : ContextMenu;
		private var aLinkMenu : Array;
		private var oBackground : Sprite;
		
		
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			this.buildUI();
			this.updateMenu();// modifie le menu contextuel de flash
		}


		/**
		 * Construit l'affichage de l'application.
		 * 
		 * 
		 */
		private function buildUI() : void
		{
			oBackground = new Sprite();
			oBackground.graphics.beginFill(0xffffff);
			oBackground.graphics.drawRect(30, 30, stage.stageWidth - 60, stage.stageHeight - 60);
			oBackground.graphics.endFill();
			this.addChild(oBackground);

			// affichage d'un champ texte
			var oText:UITextField = this.addText("Effectuer un clique droit pour des actions supplémentaires.");
			oText.x = (stage.stageWidth - oText.width) /2;
			oText.y = (stage.stageHeight - oText.height) /2;
			this.addChild(oText);
		}
		
		
		/**
		 * Modifie le menu contextuel de flash.
		 * 
		 */
		private function updateMenu() : void
		{
			// le menu contextuel
			aLinkMenu = new Array();
			oMenu = new ContextMenu();
			oMenu.hideBuiltInItems();
			
			// ajoute des liens vers des sites web
			addItem("Méthode AS3 Facile", "http://www.formation-actionscript.com", false, onLinkClic);
			
			// ouverture d'un mail
			addItem("Contactez-moi", "mailto:newsletter@actionscript-facile.com", false, onLinkClic);
			addItem("Copyright ActionScript Facile", "http://www.actionscript-facile.com", true, onLinkClic);
			
			// avec un écouteur sur le menu contextuel
			addItem("Changez la couleur du Sprite", null, true, onColorChange);
			
			this.contextMenu = oMenu;// met à jour le menu sur le Sprite principal
			oMenu = null;
			
			MonsterDebugger.trace(this, "updateMenu");
			MonsterDebugger.trace(this, aLinkMenu);
		}
		
		
		/**
		 * Enregistre un nouveau lien dans le menu.
		 * 
		 * @param label : le texte du menu
		 * @param url : l'url à appeler
		 * @param bSeparateur : ajout d'un séparateur dans le menu
		 * @param eventFunction : ajout d'une action / évènement sur le clic du menu
		 * 
		 */
		private function addItem(label : String, url : String, bSeparateur:Boolean = false, eventFunction:Function = null) : void
		{
			// création du nouvel élément dans le menu contextuel
			var oItem : ContextMenuItem = new ContextMenuItem(label);
			oItem.separatorBefore = bSeparateur;// ajout d'un séparateur juste avant le nouvel item
			oMenu.customItems.push(oItem);
			
			MonsterDebugger.trace(this, "addItem");
			MonsterDebugger.trace(this, eventFunction);
			
			// création d'un tableau contenant tous les objets "menu"
			if( url != null )
			{
				var oDataLinK:Object = new Object();
				oDataLinK.label = label;
				oDataLinK.url = url;
				aLinkMenu.push(oDataLinK);
			}
			
			if( eventFunction != null)
			{
				// ajout d'un évènement sur le clic menu contectuel
				oItem.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, eventFunction);
			}
			
		}


		/**
		 * Appel sur clic dans le menu contextuel de flash.
		 * 
		 */
		private function onColorChange(event : ContextMenuEvent) : void
		{
			MonsterDebugger.trace(this, "onColorChange");
			this.changeColor(oBackground);
		}
		
		
		
		/**
		 * Change aléatoirement la couleur d'un display object.
		 * 
		 */
		private function changeColor(oDisplay:DisplayObject) : void
		{
			// définit les couleurs primaires aléatoirement
			var red:int = int(Math.random() * 255);
			var green:int = int(Math.random() * 255);
			var blue:int = int(Math.random() * 255);
 
 			// construit la valeur hexadécimale
			var hexValue:Number = Number("0x" + red.toString(16) + green.toString(16) + blue.toString(16));
 			
			// applique la couleur au Display Object
			var colorTransform:ColorTransform = new ColorTransform();
			colorTransform.color = hexValue;
			oDisplay.transform.colorTransform = colorTransform;
		}
 
		
		
		/**
		 * Appel d'un lien.
		 * 
		 */
		private function onLinkClic(event : Event) : void
		{
			// récupère l'objet cliqué du menu contextuel
			var oLinkMenu:ContextMenuItem = ContextMenuItem(event.target);
			
			for (var i : int = 0; i < aLinkMenu.length; i++)
			{
				// si les 2 titres de menu correspondent
				if(oLinkMenu.caption == aLinkMenu[i].label)
				{
					navigateToURL(new URLRequest(aLinkMenu[i].url), "_blank");// appel de l'url
					break;// sortie de la boucle
				}
			}
			
		}
		
		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("size", 18);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;	 
		}
	}
}
